# 1.準備
# sysモジュールには、システムパラメータに関する関数が含まれている。
import sys

import pygame as pg

pg.init()  # pygameライブラリの初期化
# 横600、縦650のウィンドウ（Surfaceオブジェクト）を生成し、第２引数の指定で画面サイズを変更可能にする
screen = pg.display.set_mode((600, 650), pg.RESIZABLE)
pg.display.set_caption("MYGAME")  # ウィンドウのタイトルを設定する
player = pg.image.load("images/kaeru1.png")  # 画像ファイルの読み込み
# pygameライブラリでは、Rectオブジェクト（四角形の描画情報を保持したオブジェクト）を使用して画像等の描画範囲を設定したり変更できる。
# 画像ファイルが描画される範囲であるRectオブジェクトの位置・サイズを指定
myrect = pg.Rect(250, 550, 50, 50)

# 2.メインループ
while True:
    # 3.画面の初期化
    screen.fill(pg.Color("NAVY"))
    # 4.入力チェックや判断処理
    # myrect.x += 1  # X座標に1を追加する
    # pygame.key.get_pressed()メソッドは、全てのキーの入力状態を取得し、それをリストに格納して返す。
    key = pg.key.get_pressed()  # 押されているキーを調べて変数keyに代入
    vx = 0  # X軸方向の移動量
    vy = 0  # Y軸方向の移動量
    if key[pg.K_RIGHT]:  # 右キー
        vx = 10
    elif key[pg.K_LEFT]:  # 左キー
        vx = -10
    elif key[pg.K_UP]:  # 上キー
        vy = -10
    elif key[pg.K_DOWN]:  # 下キー
        vy = 10
    elif myrect.x + vx < 0:  # 移動した位置が画面の左端を超えたら
        vx = 10
    # 移動した位置が画面の右端を超えたら
    # get_width()メソッドは、ウィンドウの横幅を取得する。
    elif myrect.x + vx > screen.get_width() - 25:
        vx = -50
    elif myrect.y + vy < 0:  # 移動した位置が画面の上端を超えたら
        vy = 10
    # 移動した位置が画面の下端を超えたら
    # get_height()メソッドは、ウィンドウの高さを取得する。
    elif myrect.y + vy > screen.get_height() - 25:
        vy = -50
    myrect.x += vx  # 画像の表示位置にX軸方向の移動量を追加
    myrect.y += vy  # 画像の表示位置にY軸方向の移動量を追加
    # 5.描画処理
    centerx = screen.get_rect().centerx  # ウィンドウ中央のX座標
    centery = screen.get_rect().centery  # ウィンドウ中央のY座標
    # draw.rect関数(第１引数：Surfaceオブジェクト,第２引数：RGB色,第３引数：(左上のX座標,左上のY座標,横幅,高さ),第４引数：width=外枠の線の太さ)は、四角形を描画する。
    pg.draw.rect(
        screen, pg.Color("RED"), (centerx - 15, centery - 20, 30, 40), width=0
    )  # 赤い四角形を描画
    # blit(第１引数：描画対称の画像,第２引数：画像の左上基準の描画位置,第３引数：area=描画時に参照する画像のXY座標と横幅、高さ。ソース画像の中から一部分だけを切り取って描画する時に切り取る範囲として設定する。,第４引数：special_flags=描画時の合成方法)関数は、画像を他の画像上に描画する。
    screen.blit(player, myrect, area=None, special_flags=0)  # 画像ファイルを描画
    # 6.画面の表示
    pg.display.update()  # 図形を描いたスクリーン（screen）を更新する
    # pygame.timeモジュールは、時間計測、フレームレート制御、待ち時間の機能を提供する。pygame.time.Clockクラスは、時間を計測するためのオブジェクトを提供する。そのクラスのtick()メソッドは、前回のtick()メソッド呼び出しからの経過時間（ミリ秒）を取得・設定でき、フレームレート制御にも使用できる。
    pg.time.Clock().tick(60)  # フレームレートを60fpsに指定
    # 7.閉じるボタンのチェック
    # pygameライブラリでは、発生したイベントはイベントキューと呼ばれる仮想的な領域に格納される。pygame.eventモジュールは、このイベントキューからイベントオブジェクトを取り出し、処理するための機能を提供している。
    # pygame.event.get()関数は、イベントキューからイベントオブジェクトを取り出し、リストとして返す。event.typeプロパティは、イベントの種類。
    for event in pg.event.get():
        if event.type == pg.QUIT:  # 終了（閉じる）ボタンが押された
            pg.quit()  # pygameを終了する
            sys.exit()  # プログラムを終了する
