# ゲーム全体を動かしているメインプログラム
# 1.準備
import sys

import gamecontrol as gc  # gamecontrol.py（GameManagerクラス）をインポート
import pygame as pg
import resultscene as res  # resultscene.py（ResultSceneクラス）をインポート

pg.init()
screen = pg.display.set_mode((600, 650), pg.RESIZABLE)
pg.display.set_caption("MYGAME")
game = gc.GameManager(screen)  # GameManagerインスタンスの作成
result = res.ResultScene(game)  # ResultSceneインスタンスの作成

# 2.メインループ
while True:
    # 3.画面の初期化
    screen.fill(pg.Color("NAVY"))
    # 画面の下に落下エリアを描画。第３引数(左上のX座標,左上のY座標,横幅,高さ)
    pg.draw.rect(
        screen,
        pg.Color("SEAGREEN"),
        (0, screen.get_height() - 30, screen.get_width(), 30),
    )
    # 4.入力チェックや判断処理
    # ゲーム中はゲームを更新し、敵が落下エリアに落ちてゲームが停止すると結果画面を更新する。
    if game.is_playing == True:  # ゲーム中
        game.update(screen)  # GameManagerインスタンスの更新
    else:  # ゲーム停止中
        result.update(screen)  # ResultSceneインスタンスの更新

    # 5.描画処理
    # ゲームオーバー時にもゲーム状況が分かる様にGameManagerインスタンスの描画処理を表示したままにする。
    game.draw(screen)  # GameManagerインスタンスの描画
    if game.is_playing == False:  # ゲーム停止中のみ結果画面を表示する
        result.draw(screen)  # ResultSceneインスタンスの描画
    # 6.画面の表示
    pg.display.update()
    pg.time.Clock().tick(60)  # フレームレートを60fpsに指定
    # 7.閉じるボタンのチェック
    for event in pg.event.get():
        if event.type == pg.QUIT:
            pg.quit()
            sys.exit()
