# ファクトリーパターン
# ファクトリークラスから作り出されるいろいろなクラス
class Coffee:  # コーヒー
    def drink(self):
        print("コーヒーを飲む。")


class Latte:  # ラテ
    def drink(self):
        print("ラテを飲む。")


class Cappuccino:  # カプチーノ
    def drink(self):
        print("カプチーノを飲む。")


class Miss:  # 注文間違い
    def drink(self):
        pass


class Barista:  # カフェ店員クラス（ファクトリークラス）
    # 客からの注文に応じたドリンクオブジェクトを作って返すメソッド
    def order(self, type):
        role = ["コーヒー", "ラテ", "カプチーノ"]
        print(f"オーダー：{type}を注文。")
        if type == "コーヒー":
            print(f"「豆の風味が引き立つ、バランスの取れた{role[0]}です。どうぞ。」")
            return Coffee()  #
        elif type == "ラテ":
            print(f"「ほんのり甘くてまろやかな{role[1]}です。どうぞ。」")
            return Latte()
        elif type == "カプチーノ":
            print(
                f"「エスプレッソにミルクの絶妙な泡立ちが特徴の{role[2]}です。どうぞ。」"
            )
            return Cappuccino()
        else:
            print(f"{role[0]}、{role[1]}、{role[2]}のいずれか１つを注文して下さい。")
            return Miss()


mirai = Barista()  # ファクトリーインスタンスを作成
role = ["コーヒー", "ラテ", "カプチーノ"]
while True:
    type = input(
        f"[{role[0]}、{role[1]}、{role[2]}]の内から１つ注文して下さい。終わりたい場合には、「終わり」と入力して下さい。\n"
    )
    if type == "終わり":
        print("もう結構です。")
        break
    cup = mirai.order(type)
    cup.drink()
