# 結果画面（ゲームオーバー）のプログラム
import pygame as pg


class ResultScene:  # 結果画面表示用のクラス
    def __init__(self, game):
        # pygame.font.Font(第１引数：ファイル名又はファイルオブジェクト名,第２引数：フォントサイズ)は、第１引数からフォントを読み込み、フォントオブジェクトを新規に作成する。第１引数に「None」を指定した場合、Pygameの既定フォントを読み込む。
        font = pg.font.Font(None, 50)
        # プロパティ
        # ゲームを管理しているGameManagerインスタンスを格納するプロパティ
        self._game = game
        # pygame.font.Font.render(第１引数：表示したいテキスト,第２引数：Trueを指定すると文字の角部分が滑らかに描画される,第３引数：色,第４引数：文字の背景色の指定)メソッドは、指定した文字が描画されたSurfaceオブジェクトを新規に作成する。Pygameライブラリでは、作成済みのSurfaceオブジェクトに直接文字を描画することができない。
        self._msg = font.render("Press SPACE to Replay", True, pg.Color("WHITE"))
        self._gameover = pg.image.load("images/gameover.png")
        self._gameclear = pg.image.load("images/gameclear.png")

    # メソッド
    def update(self, screen):  # 更新処理
        key = pg.key.get_pressed()
        # 結果画面上でスペースキーが押されるとゲームをリセット
        if key[pg.K_SPACE]:
            self._game.reset(screen)

    def draw(self, screen):  # 描画処理
        centerx = screen.get_rect().centerx  # ウィンドウ中央のX座標
        centery = screen.get_rect().centery  # ウィンドウ中央のY座標
        screen.blit(self._msg, (centerx - 200, centery))  # 文字の描画
        if self._game.is_playing == False:  # ゲームが停止中の場合
            if self._game.is_cleared == True:  # ゲームクリアーの場合
                screen.blit(
                    self._gameclear, (centerx - 250, centery - 153)
                )  # GAME CLEAR用画像の描画
            else:  # ゲームオーバーの場合
                screen.blit(
                    self._gameover, (centerx - 250, centery - 153)
                )  # GAME OVER用画像の描画
