# pygameの画面を使って色の名前を表示するプログラム
import sys

import pygame as pg

pg.init()
screen = pg.display.set_mode((800, 600))
colors = []
# pygameで使える色は、pg.color.THECOLORSのリストに入っている
for c in pg.color.THECOLORS:
    colors.append(c)
font = pg.font.Font("fonts/ipaexg.ttf", 16)
startID = 0
while True:
    screen.fill(pg.Color("white"))
    textimg = font.render("上キー/下キーで移動", True, pg.Color("BLACK"))
    centerx = screen.get_rect().centerx  # ウィンドウ中央のX座標
    screen.blit(textimg, (centerx - 70, screen.get_height() - 40))
    # 変数に代入する値が、数値や文字列などのイミュータブル（更新不可能）オブジェクトの場合は、同一オブジェクトのままで値を更新することはできない。代入した時点では同一オブジェクトだが、新たな値に更新された時点で別のオブジェクトとなり、もう一方は元のオブジェクトのままである。
    n = startID
    for i in range(11):
        for j in range(5):
            if n < len(colors):
                c = pg.Color(colors[n])
                x = j * 150 + 30
                y = i * 50
                pg.draw.rect(screen, c, (x, y, 140, 40))
                textimg = font.render(colors[n], True, pg.Color("BLACK"))
                screen.blit(textimg, (x + 5, y + 4))
                textimg = font.render(colors[n], True, pg.Color("White"))
                screen.blit(textimg, (x + 5, y + 20))
                n += 1
    key = pg.key.get_pressed()
    if key[pg.K_DOWN]:
        startID = startID + 5
        if startID > len(colors):
            startID = len(colors) - 2
    elif key[pg.K_UP]:
        startID = startID - 5
        if startID < 0:
            startID = 0
    pg.display.update()
    pg.time.Clock().tick(30)
    for event in pg.event.get():
        if event.type == pg.QUIT:
            pg.quit()
            sys.exit()
